cordova.define("com.greenlandfs.plugin.fileManager", function(require, exports, module) {
    /*
    greenlandfs fileManager Plugin

    by LiLong
*/
    var FileManager = function() {};
    /* 
        var obj = {
            time:'2000204034',
            phone:'2323232323'
        };
        var path = '18017309500';       // save file to directorType/path/
        var fileName = 'myLastLoginTime';
        greenlandfs.plugin.fileManager.saveObject(obj,path,fileName,function(){
                                                 console.log('save success:');
                                               },function(error){
                                                console.log('save failed:'+error);
                                               }
        ); 
    */
    FileManager.saveObject = function(obj, filePath, fileName, onSuccssed, onfailed) {
        cordova.exec(onSuccssed, onfailed, "fileManager", "saveObject", [{
            obj: obj,
            fileName: fileName,
            filePath: filePath
        }]);
    };
    /* 

        var path = '18017309500';       // save file to directorType/path/
        var fileName = 'myLastLoginTime';
        greenlandfs.plugin.fileManager.loadObject(path,fileName,function(obj){
                                                 console.log('load success!');
                                                 for(var p in obj)
                                                        {
                                                            var value = obj[p];
                                                            console.log('key '  + p  + ' value is '+ value);
                                                           
                                                        }
                                               },function(error){
                                                console.log('load failed:'+error);
                                               }
        ); 
    */
    FileManager.loadObject = function(filePath, fileName, onSuccssed, onfailed) {
        cordova.exec(onSuccssed, onfailed, "fileManager", "loadObject", [{
            fileName: fileName,
            filePath: filePath

        }]);
    };

    FileManager.ALAuthorizationStatus = {
        notDetermined: 0,
        restricted: 1,
        denied: 2,
        Authorized: 3
    };

    FileManager.getALAuthorizationStatus = function(onSuccssed, onfailed) {
        cordova.exec(onSuccssed, onfailed, "fileManager", "getALAuthorizationStatus", []);
    };

    /*
       var image = document.getElementById('myImage');
       if(greenlandfs.plugin.fileManager)
       {
       greenlandfs.plugin.fileManager.getALAuthorizationStatus(function(status){
                                                               console.log('status:'+status);
                                                               if(status != greenlandfs.plugin.fileManager.restricted || status != greenlandfs.plugin.fileManager.denied)
                                                               {
                                                               greenlandfs.plugin.fileManager.saveImageInPhotosAlbum(image,function(){
                                                                                                                     console.log('success');
                                                                                                                     
                                                                                                                     },function(error){
                                                                                                                     console.log('save failed:'+error);
                                                                                                                     }
                                                                                                                     );
                                                               }
                                                               },function(error)
                                                               {
                                                               console.log('save failed:'+error);
                                                               })
       }
       */

    FileManager.saveImageInPhotosAlbum = function(imageBase64, onSuccssed, onfailed) {
        // function getBase64Image(img) {
        //      var canvas = document.createElement("canvas");
        //      canvas.width = img.width;
        //      canvas.height = img.height;

        //      var ctx = canvas.getContext("2d");
        //      ctx.drawImage(img, 0, 0, img.width, img.height);

        //      var dataURL = canvas.toDataURL("image/png");
        //      return dataURL.replace("data:image/png;base64,", "");
        // }
        // var imageDataString = getBase64Image(image);
        cordova.exec(onSuccssed, onfailed, "fileManager", "saveImageInPhotosAlbum", [imageBase64]);
    };
    /*
     
     var fileName = 'greenland_large';
     var fileType = 'jpg';
     greenlandfs.plugin.fileManager.loadImage(fileName,fileType,function(imageData){
     if(imageData)
     {
     var image = document.getElementById('myImage');
     image.src = "data:image/jpeg;base64," + imageData;
     }else
     {
     var image = document.getElementById('myImage');
     image.src = "/img/"+fileName;
     }
     },function(error){
     console.log('load failed:'+error);
     }
     );
     */
    FileManager.loadImage = function(imageName, imageType, onSuccssed, onfailed) {
        cordova.exec(onSuccssed, onfailed, "fileManager", "loadImage", [{
            fileName: imageName,
            fileType: imageType
        }]);
    };
    /*
    var fileName = 'greenland_large';
     var fileType = 'jpg';
    greenlandfs.plugin.fileManager.loadImagePath(fileName,fileType,function(imagePath){
        if(imagePath)
        {
            var image = document.getElementById('myImage');
            image.src = imagePath;
        }else
        {
            var image = document.getElementById('myImage');
            image.src = "/img/"+fileName;
        }
    },function(error){
        console.log('load failed:'+error);
    }
    );
    */
    FileManager.loadImagePath = function(imageName, imageType, onSuccssed, onfailed) {
        cordova.exec(onSuccssed, onfailed, "fileManager", "loadImagePath", [{
            fileName: imageName,
            fileType: imageType
        }]);
    };

    function convertPhoneToArray(phone) {
        if (typeof phone === 'string' && phone.indexOf(',') !== -1) {
            phone = phone.split(',');
        }
        if (Object.prototype.toString.call(phone) !== '[object Array]') {
            phone = [phone];
        }
        return phone;
    }

    FileManager.send = function(phone, message, options, success, failure) {
        // parsing phone numbers
        phone = convertPhoneToArray(phone);

        // parsing options
        var replaceLineBreaks = false;
        var androidIntent = '';
        if (typeof options === 'string') { // ensuring backward compatibility
            window.console.warn('[DEPRECATED] Passing a string as a third argument is deprecated. Please refer to the documentation to pass the right parameter: https://github.com/cordova-sms/cordova-sms-plugin.');
            androidIntent = options;
        } else if (typeof options === 'object') {
            replaceLineBreaks = options.replaceLineBreaks || false;
            if (options.android && typeof options.android === 'object') {
                androidIntent = options.android.intent;
            }
        }

        // fire
        cordova.exec(
            success,
            failure,
            'fileManager',
            'send', [phone, message, androidIntent, replaceLineBreaks]
        );
    };

    FileManager.hasPermission = function(success, failure) {
        // fire
        cordova.exec(
            success,
            failure,
            'fileManager',
            'has_permission', []
        );
    };

    module.exports = FileManager;
});
